<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(BASEPATH.'libraries/Controller.php');

/**
 * 
 */
abstract class ControllerBase extends Controller 
{
	/**
	 * コンストラクタ
	 */
    public function __construct()
    {
        parent::__construct();
    }
	/**
	 * 
	 */
	protected function _getViewData()
	{
		// データ
		$data['PageInfo'] = $this->_getPageInfo();
		//
		return $data;
	}
	/**
	 * ページ情報を作成して返します
	 */
	protected function _getPageInfo()
	{
		$CONFIG =& $this->config;
		$URI	=& $this->uri;
		//
		$infos['BaseUrl'] = $CONFIG->item('base_url');
		$infos['SiteUrl'] = $CONFIG->site_url();
		$infos['Charset'] = $CONFIG->item('charset');
		$infos['Controller'] = $URI->rsegment(1);
		$infos['FullController'] = $this->_getFullControllerName();
		$infos['Method'] = $URI->rsegment(2, 'index');
		$infos['FullControllerUrl'] = $infos['SiteUrl'] . '/' . $infos['FullController'];
		$infos['FullMethodUrl'] = $infos['FullControllerUrl'] . '/' . $infos['Method'];
		//
		return $infos;
	}
	/**
	 * 
	 */
	protected function _getFullControllerName() 
	{
		$URI =& $this->uri;
		//
		$ctrl = $URI->rsegment(1);
		//
		$fullctrl = array();
		for($i = 1; $i <= $URI->total_segments(); $i++)
		{
			$seg = $URI->segment($i);
			if($seg == $ctrl)
				break;
			$fullctrl[] = $seg;
		}
		$fullctrl[] = $ctrl;
		//
		return join('/', $fullctrl);
	}
}

/* End of file */