<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(BASEPATH.'libraries/Model.php');
require_once(APPPATH.'classes/dataobjects/DataObjectBase.class.php');	

/**
 * PaymentDriver クラス
 */
abstract class PaymentDriverBase extends Model 
{
	/**
	 * 
	 */
	protected $_merchant_info = null;
	protected $_payment_info = null;
	/**
	 * 
	 */
	protected $_submit_object = null;
	protected $_response_object = null;
	/**
	 * 
	 */
	protected $_submit_object_name = 'DataObjectBase';
	protected $_response_object_name = 'DataObjectBase';
	/**
	 * 
	 */
	protected $_last_submit_string = null;
	protected $_last_response_string = null;
	protected $_last_trans_id = null;

	/**
	 * コンストラクタ
	 */
    public function __construct() {}

	/**
	 * sale transaction
	 */
	abstract public function transactionSale($paramobj, $transid = null);
   	/**
     * authorization transaction
     */
    abstract public function transactionAuthorization($paramobj, $transid = null);
    /**
     * delayed capture transaction
     */
    abstract public function transactionDelayedCapture($paramobj, $transid = null);
	/**
	 * credit transaction
	 */
    abstract public function transactionCredit($paramobj, $transid = null); 
	/**
	 * void transaction
	 */
    abstract public function transactionVoid($paramobj, $transid = null);
//    /**
//     * inquiry transaction
//     */
//    abstract public function transactionInquiry($paramobj, $transid = null);
	/**
	 * 
	 */
    abstract public function isAvailableVoid($paramobj, $transid = null);
	/**
	 * 
	 */
    abstract public function isTransactionSucceed();
    /**
     * 
     */
    public function initialize($merchant, $payment)
    {
    	$this->_merchant_info = $merchant;
    	$this->_payment_info = $payment;
    }
    /**
     * setSubmitValue()
     */
    public function setSubmitValue($string)
    {
    	$this->_last_submit_string = $string;
    } 
    /**
     * getSubmitValue()
     */
    public function getSubmitValue()
    {
    	return $this->_last_submit_string;
    } 
    /**
     * getResponseValue()
     */
    public function setResponseValue($string)
    {
    	$this->_last_response_string = $string;
    } 
    /**
     * getResponseValue()
     */
    public function getResponseValue()
    {
    	return $this->_last_response_string;
    } 
    /**
     * getMerchantId()
     */
    public function getMerchantId()
    {
    	return $this->_merchant_info->ID;
    } 
    /**
     * getTransactionId()  美しく
     */
    public function getTransactionId()
    {
    	return $this->_last_trans_id;
    } 
    /**
     * 
     */
    public function setTransactionId($transid)
    {
		if(empty($transid))
			$transid = self::createTransactionId();
    	$this->_last_trans_id = $transid;
    	//
    	return $transid;
    } 
    /**
	 * Submit データオブジェクトのインスタンスを返します。 
	 * インスタンスが存在しなかった場合は新規に作成します。
	 * 
	 * @return DataObjectBase $this->_submit_object への参照
     */
    public function& getSubmitObject() 
    {
		if(is_null($this->_submit_object))
			$this->_submit_object = new $this->_submit_object_name();
		return $this->_submit_object;
	}
    /**
	 * Response データオブジェクトのインスタンスを返します。 
	 * インスタンスが存在しなかった場合は新規に作成します。
	 * 
	 * @return DataObjectBase $this->_response_object への参照
     */
    public function& getResponseObject() 
    {
		if(is_null($this->_response_object))
			$this->_response_object = new $this->_response_object_name();
		return $this->_response_object;
	}
    /**
     * 
     */
    public static function createTransactionId()
    {
    	$seed = md5(date("r") . mt_rand());
    	return $seed;
    }
}

/* End of file */