<?php
require_once(APPPATH.'classes/dataobjects/DataObjectBase.class.php');	
require_once(APPPATH.'classes/dataobjects/TransactionResultData.class.php');	

class PaypalResponseData extends DataObjectBase
{
	/**
	 * 既定メンバーの名前のリスト
	 */	
	protected $_propertynames = array(
		// main
		'RESULT'	=> 'RESULT',
		'PNREF'		=> 'PNREF',
		'PPREF'		=> 'PPREF',
		'RESPMSG'	=> 'RESPMSG',
		'AUTHCODE'	=> 'AUTHCODE',
		// extra
		'CVV2MATCH'	=> 'CVV2MATCH',
		'AVSADDR'	=> 'AVSADDR',
		'AVSZIP'	=> 'AVSZIP',
		'IAVS'		=> 'IAVS',
		'PROCAVS'	=> 'PROCAVS',
		'PROCCVV2'	=> 'PROCCVV2',
		'PAYMENTTYPE'	=> 'PAYMENTTYPE',
		'CORRELATIONID'	=> 'CORRELATIONID',
		'BALAMT'		=> 'BALAMT',
		'AMEXID'		=> 'AMEXID',
		'AMEXPOSDATA'	=> 'AMEXPOSDATA',
		'TRANSSTATE'	=> 'TRANSSTATE',
	);
	/**
	 * コンストラクタ
	 */
	public function __construct($datas = array())
	{
		parent::__construct($datas);
	}
	/**
	 * 
	 */
	public function toResultObject()
	{
		$obj_res = new TransactionResultData();
		//
		if($this->RESULT == 0)
			$obj_res->RESULT = TransactionResultData::APPROVED;
		elseif($this->RESULT > 0)
			$obj_res->RESULT = $this->RESULT + 10000;
		elseif($this->RESULT < 0)
			$obj_res->RESULT = $this->RESULT + 20000;
		//
		$obj_res->RESPMSG = $this->RESPMSG;
		$obj_res->PNREF	  = $this->PNREF;
		//
		return $obj_res;
	}
	/**
	 * 
	 */
	public function isSucceed()
	{
		return $this->RESULT == 0;
	}
	/**
	 * 
	 */
	public function isAvailableVoid()
	{
		//
		$res = false;
		//
		switch($this->TRANSSTATE)
		{
			// PayflowPro_Guide P.162 参照
			case 3:
			case 6:
			case 7:
				$res = true;
				break;
			//
			default:
				$res = false;
				break;
		}
		//
		return $res;
	}
}

/* End of file */