<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/HttpRequestParserModelBase.abstract.php');	
require_once(APPPATH.'classes/dataobjects/TransactionResultData.class.php');	

/**
 * SaleTransactionModel クラス
 */
class SaleTransactionModel extends HttpRequestParserModelBase 
{
	/**
	 * @var string リクエストデータを保持する DataObjectBase 型のクラスの名前
	 * @abstract
	 */
	protected $_object_name = 'DataObjectBase';
	/**
	 * @var array[] 妥当性検査情報の配列
	 * @abstract
	 */
	protected $_validation_rules = array(
		'MERCHANTID'	=> array('trim|xss_clean|required', TransactionResultData::INVALID_MERCHANTID),
		'MERCHANTPW'	=> array('trim|xss_clean|required', TransactionResultData::INVALID_MERCHANTPW),
		'CRDNUM'		=> array('trim|xss_clean|required|numeric', TransactionResultData::INVALID_CRDNUM),
		'CRDEXP'		=> array('trim|xss_clean|required|card_expire', TransactionResultData::INVALID_CRDEXP),
		'FIRSTNAME'		=> array('trim|xss_clean|required', TransactionResultData::INVALID_FIRSTNAME),
		'LASTNAME'		=> array('trim|xss_clean|required', TransactionResultData::INVALID_LASTNAME),
		'AMOUNT'		=> array('trim|xss_clean|required|numeric', TransactionResultData::INVALID_AMOUNT),
		'CURRENCY'		=> array('trim|xss_clean|required', TransactionResultData::INVALID_CURRENCY),
		'PAYMENTTYPE'	=> array('trim|xss_clean|required|preg_match[/^(SALE;AUTH)$/i]', TransactionResultData::INVALID_PAYMENTTYPE),
	);

	/**
	 * コンストラクタ
	 */
    public function __construct()
    {
        parent::__construct();
    }
}

/* End of file */